GET Retrieve Account Deposit Fields for Recipient-Account

GET /reference-data/v1/account-deposit-fields/recipient-account

Development Guide

Retrieves all fields for Account Deposit for Recipient Account creation of Target Account Profile required to for the bank, wallet or card deposit serviceOption in a given destination country. The endpoint returns an array of service options and keys. The keys are account fields that need to be collected from the consumer to transfer funds to the corresponding bank, wallet or card.

Once the account data has been gathered from the consumer, the application can choose to subsequently call the Create Target Account API to validate the account details and create a unique targetAccountProfileId to link the account and receiver/beneficiary.



1. Prepare headers & authentication:

Call the 'Retrieve Account Deposit Fields for Recipient Account' endpoint with a GET HTTP method, providing the OAuth access_token in the header and all other required header values


Note: MoneyGram uses the OAuth 2.0 framework. The application must use their OAuth client credentials to generate an accessToken by calling the Get access token endpoint. The token is valid for 1 hour and must be passed as a header value in all subsequent API HTTP calls. Learn More


🚀

Launch Code Example:

👉 Reference Data - Retrieve Account Deposit Fields for Recipient-Account - Headers




2. Provide agentPartnerId & destinationCountryCode as query parameter.

The application must provide the agentPartnerId & destinationCountryCode as query parameters. An array of bank, wallet and card deposit serviceOptions and associated keys will be returned.


🚀

Launch Code Example:

👉 Reference Data - Retrieve Account Deposit Fields for Recipient-Account - agentPartnerId & destinationCountryCode




3. Provide serviceOptionCode as query parameter (optional):

The Retrieve Account Deposit Fields for Recipient Account allows the application to specify one or all service options to be returned to the given destination country:


  • Retrieve all service options: If the serviceOptionCode is not provided in the request body, the Retrieve Account Deposit Fields Recipient Account endpoint will return all service options in an array (i.e. the API will return all cash pickup, bank, wallet & card deposit options available to the destination country). Learn More


    OR


  • Retrieve a single service option: If the serviceOptionCode is provided in the request body, the Retrieve Account Deposit Fields Recipient Account endpoint will only return an array for that specified code. (e.g. if "serviceOptionCode": "Bank_Deposit" is passed in the request, the endpoint will only return the bank deposit options available to the destination country) Learn More

Note: Only the following serviceOptionCode values are accepted: CARD_DEPOSIT BANK_DEPOSIT, DIRECT_TO_ACCT, HOME_DELIVERY


🚀

Launch Code Example:

👉 Reference Data - Retrieve Account Deposit Fields for Recipient-Account - Service Option Code Not Provided (optional)

👉 Reference Data - Retrieve Account Deposit Fields for Recipient-Account - Service Option Code Provided (optional)




4. Make the request and handle the response:

The application will call the 'Retrieve Account Deposit Fields for Recipient Account' endpoint with a GET HTTP method. The 'Retrieve Account Deposit Fields Recipient Account' API will generate a response with an array of service options and field metadata. The application must build to handle the following response scenarios.


  • Success | Parse the Response | 200 OK HTTP Status
    When the 'Retrieve Account Deposit Fields for Recipient Account' endpoint responds with a 200 HTTP Status. An array of serviceOptions will be returned, with each service option containing an array of keyInfo. For each key returned, the endpoint will also provide the meta-data key, dataType, fieldLabel, required, fieldMin, fieldMax and regEx

  • Failed | Handle the Error | 400 Bad Request HTTP Status
    When the 'Retrieve Account Deposit Fields for Recipient Account' endpoint responds with 400 HTTP Status, specific error code/s will be returned with an array of offending fields. The application will need to resolve these errors and resubmit request.

🚀

Launch Code Example:

👉 Reference Data - Retrieve Account Deposit Fields for Recipient-Account - 200 OK

👉 Reference Data - Retrieve Account Deposit Fields for Recipient-Account - 400 Bad Request




4. You're Done! Proceed to Create Target Account ProfileId

Once the account data has been gathered from the consumer, the application can choose to subsequently call the Create Target Account API to validate the account details and create a unique targetAccountProfileId to link the account and receiver/beneficiary.




Business Rules to Code


🔎

Business Rules to Code

ISO Standards: The Account Deposit API uses ISO Standards for country values. MoneyGram provide other Reference Data APIs which can be queried to understand and list the supported values and associated metadata. Learn More

serviceOptions: MoneyGram provide other Reference Data APIs which can be queried to understand the supported service options per designation country. Learn More




Code Examples


const axios = require('axios');
const { v4: uuidv4 } = require('uuid');

const accountDepositFieldsRegistration = async () => {

    // Step 1: Read configuration values with upmost security
    const token = "your_access_token_from_oauth_response"
    // For production - api.moneygram.com & For test - sandboxapi.moneygram.com
    const host = "sandboxapi.moneygram.com";
    const url = 'https://' + host + '/reference-data/v1/account-deposit-fields/recipient-account';

    // Step 2: Create the GET request headers & params
    const headers = {
        'Content-Type': 'application/json',
        'X-MG-ClientRequestId': uuidv4(), // New UUID for each request tracing
        'Authorization': 'Bearer ' + token,
    };

    const params = {
        targetAudience: "AGENT_FACING",
        agentPartnerId: "your_partner_id",
        userLanguage: "en-US",
        destinationCountryCode: "USA"
    }

    try {
        // Step 3: Send the request and obtain the response
        axios.get(url, { params, headers })
            .then(function (response) {
                // Step 4: Parse the success response and process further
                console.log(JSON.stringify(response.data, null, 2))
            })
            .catch(function (error) {
                // Step 5: Parse the error response and handle the errors
                if (error.response) {
                    console.log('Response status:', error.response.status);
                    console.log('Response body:', error.response.data);
                } else {
                    // TODO: handle generic errors
                    console.error('Error:', error.message);
                }
            });
    } catch (error) {
        // TODO: handle exception
        console.error('Error:', error.message);
    }
};

accountDepositFields();
import requests
import uuid
import json

def account_deposit_fields_registration():

    # Step 1: Read configuration values with upmost security
    token = "your_access_token_from_oauth_response"
    # For production - api.moneygram.com & For test - sandboxapi.moneygram.com
    host = "sandboxapi.moneygram.com";
    url = 'https://' + host + '/reference-data/v1/account-deposit-fields/recipient-account';

    # Step 2: Create the GET request headers & params
    headers = {
        'Content-Type': 'application/json',
        'X-MG-ClientRequestId': str(uuid.uuid4()), # New UUID for each request tracing
        'Authorization': 'Bearer ' + token,
    }

    params = {
        'targetAudience': 'AGENT_FACING',
        'agentPartnerId': 'your_partner_id',
        'userLanguage': 'en-US',
        'destinationCountryCode': "USA",
    }

    try:
        # Step 3: Send the request and obtain the response
        response = requests.get(url, params=params, headers=headers)

        # Step 4: Parse the success response and process further
        if response.status_code == 200:
            parsed_response = json.dumps(json.loads(response.text), indent=2)
            print(parsed_response)
        else:
            # Print the error message if request fails
            # TODO: handle exception
            print("Request failed with status code:", response.status_code)
            print(json.loads(json.dumps(response.text, indent=4)))

    except requests.exceptions.RequestException as e:
        # Print any error that occurred during the request
        # TODO: handle exception
        print("An error occurred:", e)

account_deposit_fields_registration()
package status;

import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.UUID;

public class AccountDepositFieldsRegistration{

    public static void main(String[] args) {
        // Step 1: Read configuration values with upmost security
        String token = "your_access_token_from_oauth_response";

        // For production - api.moneygram.com & For test - sandboxapi.moneygram.com
        String host = "sandboxapi.moneygram.com";

        // Step 2: Create the GET request headers & params
        // Mandatory Query params
        String agentPartnerId = "your_partner_id";
        String userLanguage = "en-US";
        String destinationCountryCode = "USA";

        // Optional Query params
        String targetAudience = "AGENT_FACING";

        String uri = "https://" + host + "/reference-data/v1/account-deposit-fields/recipient-account?"
                + "agentPartnerId=" + agentPartnerId
                + "&userLanguage=" + userLanguage
                + "&destinationCountryCode=" + destinationCountryCode
                + (targetAudience.isBlank() ? "" : "&targetAudience=" + targetAudience);

        HttpClient httpClient = HttpClient.newHttpClient();
        HttpRequest request = HttpRequest.newBuilder()
                .uri(URI.create(uri))
                .GET()
                .setHeader("Authorization", "Bearer " + token)
                .setHeader("X-MG-ClientRequestId", String.valueOf(UUID.randomUUID()))
                .build();

        try {
            // Step 3: Send the request and obtain the response
            HttpResponse<String> response = httpClient.send(request, HttpResponse.BodyHandlers.ofString());

            // Retrieve the status code and body from the response
            int statusCode = response.statusCode();

            // Step 4: Parse the success response and process further
            if (statusCode == 200) {
                String responseBody = response.body();
                System.out.println(responseBody);
            } else {
                // Step 5: Parse the error response and handle the errors
                String responseBody = response.body();
                System.out.println(responseBody);
            }
        } catch (Exception e) {
            e.printStackTrace();
            // TODO: handle exception
        }

    }
}




API Structure


Header Parameters


Field

Type

Required/
Optional

Description

X-MG-ClientRequestId

String

Required

Client Request ID that can be passed by the client application. Client request ID must be unique within a single session for unique requests. This attribute can be used for ensuring idempotent request processing for some APIs. MoneyGram recommends using a UUID for this field value.




Query Parameters

Field

Type

Required/ Optional

Description

targetAudience

String

Optional

Tailors MoneyGram’s error messages and field metadata to an in-store, digital or crypto consumer. (Enumerated value) NOTE: For a full list of accepted target audience values, see the TARGET_AUDIENCE enumeration from the Reference Data Enumerations endpoint.

agentPartnerId

String

Required

Unique agent or partner identifier

userLanguage

String

Required

Language used by the user/operator

destinationCountryCode

String

Required

Transaction Destination Country (ISO alpha-3 code)

serviceOptionCode

String

Optional

Unique category code to identify the transaction method

serviceOptionRoutingCode

String

Optional

Unique code to identify the individual transaction method




Response Fields

Field

Type

Required/ Optional

Description

destinationCountryCode

String

Optional

Transaction Destination Country (ISO alpha-3 code)

serviceOptions.serviceOptionCode

String
Max length: 21

Required

Unique category code to identify the transaction method
NOTE: For a full list of accepted service option codes per destination country see the Reference Data API Module: service-options endpoint.

serviceOptions.serviceOptionName

String
Max length: 40

Required

Consumer facing name to identify the transaction method
NOTE: For a full list of accepted service option display names per destination country see the Reference Data API Module: service-options endpoint.

serviceOptions.serviceOptionRoutingCode

String

Optional

Unique code to identify the individual transaction method
NOTE: For a full list of accepted service option routine codes per destination country see the Reference Data API Module: service-options endpoint.

serviceOptions.serviceOptionRoutingName

String
Max length: 50

Optional

Unique name to identify the individual transaction method

serviceOptions.keyInfo

Array

Required

Array of account deposit field names and related field metadata


serviceOptions.KeyInfo Array Structure

FieldName/Metadata

Description

Example Value

serviceOptions.keyInfo.Key

Field name described in dot notation

sender.name.firstName

serviceOptions.keyInfo.dataType

Data type of the key

string, boolean, number

serviceOptions.keyInfo.fieldLabel

User facing label for the key for use on the UI. Can be overwritten if required.

First name

serviceOptions.keyInfo.required

Flag to Indicate if the key is required or optional

true

serviceOptions.keyInfo.displayOrder

UI display order for the key.
NOTE: The displayOrder is only returned for a Key that begin with targetAccount.

"3"
NOTE: The account-deposit-fields response may return one or more targetAccount fields for a service-option. The displayOrder will be listed in the recommended order they should be displayed on the UI.

serviceOptions.keyInfo.fieldMin

Min Key field length

"0"

serviceOptions.keyInfo.fieldMax

Max Key field length

"255"

serviceOptions.keyInfo.regEx

Regular expression for data validation of the Key.

"^([a-zA-Z \\À-\\ſ\\\\-\\\\'\\/])\\*$"

serviceOptions.keyInfo.exampleText

Example field value

First name

serviceOptions.keyInfo.enumerationItem

An array of accepted values for the key.

[ {"value": "22", "description": "Checking"}, { "value": "32",  "description": "Saving"} ]